Index: trunk/src/VBox/Devices/Audio/DevIchAc97.cpp
===================================================================
--- trunk/src/VBox/Devices/Audio/DevIchAc97.cpp	(revision 89732)
+++ trunk/src/VBox/Devices/Audio/DevIchAc97.cpp	(revision 89733)
@@ -1847,5 +1847,5 @@
  * Adds all current driver streams to a specific mixer sink.
  *
- * Called by ichac97R3StreamOpen().
+ * Called by ichac97R3StreamSetUp().
  *
  * @returns VBox status code.
@@ -1916,5 +1916,5 @@
  * Removes all driver streams from a specific mixer sink.
  *
- * Called by ichac97R3StreamOpen() and ichac97R3StreamsDestroy().
+ * Called by ichac97R3StreamSetUp() and ichac97R3StreamsDestroy().
  *
  * @param   pDevIns     The device instance.
@@ -1979,7 +1979,7 @@
 
 /**
- * Opens an AC'97 stream with its current mixer settings.
- *
- * This will open an AC'97 stream with 2 (stereo) channels, 16-bit samples and
+ * Sets up an AC'97 stream with its current mixer settings.
+ *
+ * This will set up an AC'97 stream with 2 (stereo) channels, 16-bit samples and
  * the last set sample rate in the AC'97 mixer for this stream.
  *
@@ -1993,6 +1993,6 @@
  *                      Otherwise re-opening only will happen if the PCM properties have changed.
  */
-static int ichac97R3StreamOpen(PPDMDEVINS pDevIns, PAC97STATE pThis, PAC97STATER3 pThisCC, PAC97STREAM pStream,
-                               PAC97STREAMR3 pStreamCC, bool fForce)
+static int ichac97R3StreamSetUp(PPDMDEVINS pDevIns, PAC97STATE pThis, PAC97STATER3 pThisCC, PAC97STREAM pStream,
+                                PAC97STREAMR3 pStreamCC, bool fForce)
 {
     /*
@@ -2216,5 +2216,5 @@
 
 /**
- * Closes an AC'97 stream.
+ * Tears down an AC'97 stream (counter part to ichac97R3StreamSetUp).
  *
  * Empty stub at present, nothing to do here as we reuse streams and only really
@@ -2223,5 +2223,5 @@
  * @param   pStream             The AC'97 stream to close (shared).
  */
-static void ichac97R3StreamClose(PAC97STREAM pStream)
+static void ichac97R3StreamTearDown(PAC97STREAM pStream)
 {
     RT_NOREF(pStream);
@@ -2231,6 +2231,6 @@
 
 /**
- * Re-opens (that is, closes and opens again) an AC'97 stream on the backend
- * side with the current AC'97 mixer settings for this stream.
+ * Tears down and sets up an AC'97 stream on the backend side with the current
+ * AC'97 mixer settings for this stream.
  *
  * @returns VBox status code.
@@ -2243,6 +2243,6 @@
  *                      Otherwise re-opening only will happen if the PCM properties have changed.
  */
-static int ichac97R3StreamReOpen(PPDMDEVINS pDevIns, PAC97STATE pThis, PAC97STATER3 pThisCC,
-                                 PAC97STREAM pStream, PAC97STREAMR3 pStreamCC, bool fForce)
+static int ichac97R3StreamReSetUp(PPDMDEVINS pDevIns, PAC97STATE pThis, PAC97STATER3 pThisCC,
+                                  PAC97STREAM pStream, PAC97STREAMR3 pStreamCC, bool fForce)
 {
     LogFlowFunc(("[SD%RU8]\n", pStream->u8SD));
@@ -2251,6 +2251,6 @@
     Assert(pStreamCC - &pThisCC->aStreams[0] == pStream->u8SD);
 
-    ichac97R3StreamClose(pStream);
-    return ichac97R3StreamOpen(pDevIns, pThis, pThisCC, pStream, pStreamCC, fForce);
+    ichac97R3StreamTearDown(pStream);
+    return ichac97R3StreamSetUp(pDevIns, pThis, pThisCC, pStream, pStreamCC, fForce);
 }
 
@@ -2284,5 +2284,5 @@
 
         /* (Re-)Open the stream if necessary. */
-        rc = ichac97R3StreamOpen(pDevIns, pThis, pThisCC, pStream, pStreamCC, false /* fForce */);
+        rc = ichac97R3StreamSetUp(pDevIns, pThis, pThisCC, pStream, pStreamCC, false /* fForce */);
 
         /* Re-register the update job with the AIO thread with correct sched hint.
@@ -2321,5 +2321,5 @@
     {
         rc = AudioMixerSinkDrainAndStop(pSink, pStreamCC->State.pCircBuf ? (uint32_t)RTCircBufUsed(pStreamCC->State.pCircBuf) : 0);
-        ichac97R3StreamClose(pStream);
+        ichac97R3StreamTearDown(pStream);
     }
 
@@ -2360,5 +2360,5 @@
  * @param   pStream             The AC'97 stream to destroy (shared).
  * @param   pStreamCC           The AC'97 stream to destroy (ring-3).
- * @sa      ichac97R3StreamCreate
+ * @sa      ichac97R3StreamConstruct
  */
 static void ichac97R3StreamDestroy(PAC97STATER3 pThisCC, PAC97STREAM pStream, PAC97STREAMR3 pStreamCC)
@@ -2366,5 +2366,5 @@
     LogFlowFunc(("[SD%RU8]\n", pStream->u8SD));
 
-    ichac97R3StreamClose(pStream);
+    ichac97R3StreamTearDown(pStream);
 
     int rc2 = RTCritSectDelete(&pStreamCC->State.CritSect);
@@ -2412,5 +2412,5 @@
  * @sa      ichac97R3StreamDestroy
  */
-static int ichac97R3StreamCreate(PAC97STATER3 pThisCC, PAC97STREAM pStream, PAC97STREAMR3 pStreamCC, uint8_t u8SD)
+static int ichac97R3StreamConstruct(PAC97STATER3 pThisCC, PAC97STREAM pStream, PAC97STREAMR3 pStreamCC, uint8_t u8SD)
 {
     LogFunc(("[SD%RU8] pStream=%p\n", u8SD, pStream));
@@ -3400,5 +3400,5 @@
                         /** @todo r=bird: Why reopen it now?  Can't we put that off till it's
                          *        actually used? */
-                        ichac97R3StreamReOpen(pDevIns, pThis, pThisCC, &pThis->aStreams[AC97SOUNDSOURCE_PO_INDEX],
+                        ichac97R3StreamReSetUp(pDevIns, pThis, pThisCC, &pThis->aStreams[AC97SOUNDSOURCE_PO_INDEX],
                                               &pThisCC->aStreams[AC97SOUNDSOURCE_PO_INDEX], true /* fForce */);
 
@@ -3406,5 +3406,5 @@
                         /** @todo r=bird: Why reopen it now?  Can't we put that off till it's
                          *        actually used? */
-                        ichac97R3StreamReOpen(pDevIns, pThis, pThisCC, &pThis->aStreams[AC97SOUNDSOURCE_PI_INDEX],
+                        ichac97R3StreamReSetUp(pDevIns, pThis, pThisCC, &pThis->aStreams[AC97SOUNDSOURCE_PI_INDEX],
                                               &pThisCC->aStreams[AC97SOUNDSOURCE_PI_INDEX], true /* fForce */);
                     }
@@ -3420,5 +3420,5 @@
                         /** @todo r=bird: Why reopen it now?  Can't we put that off till it's
                          *        actually used? */
-                        ichac97R3StreamReOpen(pDevIns, pThis, pThisCC, &pThis->aStreams[AC97SOUNDSOURCE_MC_INDEX],
+                        ichac97R3StreamReSetUp(pDevIns, pThis, pThisCC, &pThis->aStreams[AC97SOUNDSOURCE_MC_INDEX],
                                               &pThisCC->aStreams[AC97SOUNDSOURCE_MC_INDEX], true /* fForce */);
                     }
@@ -3440,5 +3440,5 @@
                         /** @todo r=bird: Why reopen it now?  Can't we put that off till it's
                          *        actually used? */
-                        ichac97R3StreamReOpen(pDevIns, pThis, pThisCC, &pThis->aStreams[AC97SOUNDSOURCE_PO_INDEX],
+                        ichac97R3StreamReSetUp(pDevIns, pThis, pThisCC, &pThis->aStreams[AC97SOUNDSOURCE_PO_INDEX],
                                               &pThisCC->aStreams[AC97SOUNDSOURCE_PO_INDEX], true /* fForce */);
                     }
@@ -3457,5 +3457,5 @@
                         /** @todo r=bird: Why reopen it now?  Can't we put that off till it's
                          *        actually used? */
-                        ichac97R3StreamReOpen(pDevIns, pThis, pThisCC, &pThis->aStreams[AC97SOUNDSOURCE_MC_INDEX],
+                        ichac97R3StreamReSetUp(pDevIns, pThis, pThisCC, &pThis->aStreams[AC97SOUNDSOURCE_MC_INDEX],
                                               &pThisCC->aStreams[AC97SOUNDSOURCE_MC_INDEX], true /* fForce */);
                     }
@@ -3474,5 +3474,5 @@
                         /** @todo r=bird: Why reopen it now?  Can't we put that off till it's
                          *        actually used? */
-                        ichac97R3StreamReOpen(pDevIns, pThis, pThisCC, &pThis->aStreams[AC97SOUNDSOURCE_PI_INDEX],
+                        ichac97R3StreamReSetUp(pDevIns, pThis, pThisCC, &pThis->aStreams[AC97SOUNDSOURCE_PI_INDEX],
                                               &pThisCC->aStreams[AC97SOUNDSOURCE_PI_INDEX], true /* fForce */);
                     }
@@ -4393,5 +4393,5 @@
     for (unsigned i = 0; i < AC97_MAX_STREAMS; i++)
     {
-        rc = ichac97R3StreamCreate(pThisCC, &pThis->aStreams[i], &pThisCC->aStreams[i], i /* SD# */);
+        rc = ichac97R3StreamConstruct(pThisCC, &pThis->aStreams[i], &pThisCC->aStreams[i], i /* SD# */);
         AssertRCReturn(rc, rc);
     }